#############################################################################
#                                                                           #
# Coded by: Opposing (Fz_Egg@yahoo.com)                                     #
# Version: 1.4                                                              #
# Released: May 27, 2009                                                    #
# Source: http://Sir-Fz.blogspot.com/                                       #
##                                                                          #
# Description: Pings users who type !ping in public or pings nicks in the   #
#              channel if !ping nick is typed, then replies with their ping #
#              reply on channel. Has protection against excess ping         #
#              requests.                                                    #
#                                                                           #
# Available Commands:                                                       #
# - Pub: !ping [nick]: pings user or nick and displays the ping reply.      #
# - DCC: .chanset #channel +pingchan: enables the script on #channel.       #
#                                                                           #
# History:                                                                  #
#         - 1.4: Fixed an issue where some clients to not respond to ping   #
#                replies.                                                   #
#         - 1.3: Changed ping method again + added dynamic chan setting.    #
#         - 1.2: Used a new more efficient method to catch ping reply.      #
#         - 1.1: Added ability to ping other users in chan and added        #
#           protection against ping request floods.                         #
#         - 1.0: First release.                                             #
#                                                                           #
# Report bugs/suggestion to Fz_Egg@yahoo.com                                #
#                                                                           #
# Copyright  2005 Opposing (aka Sir_Fz)                                    #
#                                                                           #
# This program is free software; you can redistribute it and/or modify      #
# it under the terms of the GNU General Public License as published by      #
# the Free Software Foundation; either version 2 of the License, or         #
# (at your option) any later version.                                       #
#                                                                           #
# This program is distributed in the hope that it will be useful,           #
# but WITHOUT ANY WARRANTY; without even the implied warranty of            #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
# GNU General Public License for more details.                              #
#                                                                           #
# You should have received a copy of the GNU General Public License         #
# along with this program; if not, write to the Free Software               #
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA #
#                                                                           #
#############################################################################
#
######################################################################
# Code starts here, please do not edit anything unless you know TCL: #
# __________________________________________________________________ #

setudef flag pingchan

bind pub - !ping pub:ping
bind ctcr - PING ctcr:ping

proc pub:ping {nick uhost hand chan arg} {
 global pingreq pingp
 if {![channel get $chan pingchan]} { return 0 }
 if ![info exists pingp($chan)] { set pingp($chan) 0 }
 utimer 2 [list incr pingp($chan) -1]
 if {[incr pingp($chan)] < 3} {
  if {[set targ [lindex [split $arg] 0]] == ""} {
   putserv "PRIVMSG $nick :\001PING [unixtime]\001"
   set pingreq([string tolower $nick]) "[clock clicks -milliseconds]:$chan"
  } {
   if {[string equal -nocase "me" $targ] && ![onchan $targ $chan]} {
    putserv "PRIVMSG $nick :\001PING [unixtime]\001"
    set pingreq([string tolower $nick]) "[clock clicks -milliseconds]:$chan"
   } {
    if {[onchan $targ $chan]} {
     putserv "PRIVMSG $targ :\001PING [unixtime]\001"
     set pingreq([string tolower $targ]) "[clock clicks -milliseconds]:$chan"
    } {
     puthelp "PRIVMSG $chan :$targ is not here."
    }
   }
  }
 }
}

proc ctcr:ping {nick uhost hand dest keyword arg} {
 global pingreq
 if {![info exists pingreq([set nnick [string tolower $nick]])]} { return 1 }
 foreach {t c} [split $pingreq($nnick) :] {break}
 if {[string is integer -strict $t]} {
  putserv "PRIVMSG $c :\[\002$nick\002 PING reply\]: [expr {abs([clock clicks -milliseconds] - $t) / 1000.0}] seconds."
 }
 unset pingreq($nnick)
}

putlog "Ping.tcl v1.4 by Opposing (a.k.a Sir_Fz) Loaded..."